local sStats_mail, sStats_mailText = sStats:CreateModule("mail")

-- Update Function
local function UpdateMail()
	if HasNewMail() then
		sStats_mail:SetScript("OnEnter", function(self)
			MinimapMailFrameUpdate()
			
			local send1, send2, send3 = GetLatestThreeSenders()
			local toolText;

			GameTooltip:SetOwner(sStats_mail, "ANCHOR_CURSOR")
			if (send1 or send2 or send3) then
				GameTooltip:AddLine(HAVE_MAIL_FROM)
			else
				GameTooltip:AddLine(HAVE_MAIL)
			end

			if send1 then GameTooltip:AddLine(string.format("|cffffffff%s|r", send1)) end
			if send2 then GameTooltip:AddLine(string.format("|cffffffff%s|r", send2)) end
			if send3 then GameTooltip:AddLine(string.format("|cffffffff%s|r", send3)) end

			GameTooltip:Show()
		end);
		sStats_mail:SetScript("OnLeave", function()
			if GameTooltip:IsShown() then GameTooltip:Hide() end
		end);

		sStats:SetModuleText(sStats_mailText, "New Mail", "")
	else
		sStats:SetModuleText(sStats_mailText, "No Mail", "")
		
		sStats_mail:SetScript("OnEnter", nil)
		sStats_mail:SetScript("OnLeave", nil)
	end
end

-- Refresh Timer
local RefreshTimer_Interval = 3
local RefreshTimer = CreateFrame("FRAME")
RefreshTimer:Hide()
RefreshTimer:SetScript("OnUpdate", function(self, elapsed)
	RefreshTimer_Interval = RefreshTimer_Interval - elapsed
	if (RefreshTimer_Interval <= 0) then
		UpdateMail()
		RefreshTimer:Hide()
		RefreshTimer_Interval = 3
	end
end)

-- Initialize
sStats.RegisterCallback(sStats_mail, "sStats_Modules_Ready", function()

	MiniMapMailFrame:Hide()
	MiniMapMailFrame.Show = function() end

	sStats_mail:RegisterEvent("PLAYER_ENTERING_WORLD")
	sStats_mail:RegisterEvent("UPDATE_PENDING_MAIL")
	sStats_mail:RegisterEvent("MAIL_CLOSED")
	sStats_mail:RegisterEvent("MAIL_SHOW")
	sStats_mail:RegisterEvent("MAIL_INBOX_UPDATE")

	sStats_mail:SetScript("OnEvent", function()	
		if event == "PLAYER_ENTERING_WORLD" then
			RefreshTimer:Show()
		end
		
		UpdateMail()		
	end)

end)